unit Unit1;
//unit uRS232BAR;
interface      
uses

  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Spin, _MB_USB;
type
  TF_FTUSB = class(TForm)
    SpE_pnr: TSpinEdit;
    Label1: TLabel;
    e_ex: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    e_ey: TEdit;
    Timer1: TTimer;
    b_schliessen: TButton;
    b_oeffnen: TButton;
    CheckBox1: TCheckBox;
    Label4: TLabel;
    Label5: TLabel;
    e_ez: TEdit;
    e_et: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    SpE_2pnr: TSpinEdit;
//    procedure b_schClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure b_schliessenClick(Sender: TObject);
    procedure b_oeffnenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure e_exKeyPress(Sender: TObject; var Key: Char);
//    procedure b_einzelClick(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  F_FTUSB: TF_FTUSB;
  ch : integer;
  Fehler : integer;
  s_eing:array[1..16] of tshape;
  l_eing:array[1..16] of tlabel;
  rgm:array[1..8] of tRadioGroup;
  ok:boolean;
implementation

{$R *.DFM}


procedure put;
var k:integer;    c:byte;
    s:string;
  function cai(i:integer):char;
  begin
     case i of
      0:result:='a';
      1:result:='r';
      2:result:='l';
      else result:='a'
      end
  end;
begin
  with F_FTUSB do begin
    //Motoren setzen
    for k:=1 to 4*_Anzahl_interfaces do
      motor(k,cai(RGM[k].itemindex));
//    memo1.lines.add('Motoren fertig'); //exit;

    //Eingnge lesen
    for k:=1 to 8*_Anzahl_interfaces do begin
      if taster(k) then s_eing[k].brush.color:=clred
                   else s_eing[k].brush.color:=clgreen;
                    end;

   //Widerstnde auslesen
      e_ex.text:=IntToStr(poti('X'));
      e_ey.text:=IntTostr(poti('Y'));
  if _Anzahl_interfaces=2 then begin
      e_ez.text:=IntTostr(poti('Z'));
      e_et.text:=IntTostr(poti('T'));
      end;

   end
end;


procedure TF_FTUSB.Timer1Timer(Sender: TObject);
begin
  if ok then put
end;

procedure TF_FTUSB.b_schliessenClick(Sender: TObject);
var k:integer;
begin
  timer1.enabled:=false;
  for k:=1 to 4*_Anzahl_interfaces do rgm[k].itemindex:=0;
  put; // alle Motoren aus
  for k:=1 to 8*_Anzahl_interfaces do s_eing[k].brush.color:=clgray; //Taster unwirksam
  e_ex.text:='---'; e_ey.text:='---'; //Potis aus
  if _Anzahl_interfaces=2 then begin
     _port2_schliessen;
     e_ez.text:='---'; e_et.text:='---';
     end;
  _port_schliessen;
  b_schliessen.enabled:=false;
  b_oeffnen.enabled:=true;
    F_FTUSB.caption:='Fischertechnik USB';
  ok:=false
end;



procedure TF_FTUSB.b_oeffnenClick(Sender: TObject);
var i:integer;
begin
  if checkbox1.checked then begin //_Anzahl_interfaces:=2;
                              F_FTUSB.width:=800;
                              e_ez.visible:=true;
                              e_et.visible:=true;
                              label3.visible:=true;
                              label4.visible:=true;
                              label5.visible:=true;
                              label6.visible:=true;
                              label7.visible:=true;
                              spE_2pnr.visible:=true;
                              end
                       else begin //_Anzahl_interfaces:=1;
                              F_FTUSB.width:=420;
                              e_ez.visible:=false;
                              e_et.visible:=false;
                              label3.visible:=false;
                              label4.visible:=false;
                              label5.visible:=false;
                              label6.visible:=false;
                              label7.visible:=false;
                              spE_2pnr.visible:=false;
                              end;

  Case _port_oeffnen(SpE_pnr.value) of
    1:  begin MessageDlg('Fehler beim Verbindungsaufbau, falsche Portnummer?' ,mtError,[mbAbort] ,0); exit end;
    2:  begin MessageDlg('Interface reagiert nicht! Stromversorgung ok?' ,mtError,[mbAbort] ,0); exit end;
    end;
//sleep(20);
   if not checkbox1.checked then ok:=true
                            else begin//also zweites Interface ffnen
      if SpE_2pnr.value=SpE_pnr.value then begin
         MessageDlg('Zwei gleiche Portnummern sind nicht mglich!',mTError,[mbAbort],0);
         _port_schliessen; Exit end;
  Case _port2_oeffnen(SpE_2pnr.value) of
    1:  begin MessageDlg('Keine Verbindung zu 2. Interface, falsche Portnummer?' ,mtError,[mbAbort] ,0);
        _port_schliessen;exit end;
    2:  begin MessageDlg('2. Interface reagiert nicht! Stromversorgung ok?' ,mtError,[mbAbort] ,0);
        _port_schliessen;exit end;
                  end;
     ok:=true;
     end;
  for i:=1 to 8 do
    if rgm[i]=nil then begin
    rgm[i]:=TRadiogroup.create(self);
    rgm[i].parent:=self;
    rgm[i].items.add('aus'); rgm[i].items.add('rechts');rgm[i].items.add('links');
    rgm[i].itemindex:=0;
    rgm[i].top:=72; rgm[i].left:=16+(i-1)*96;
    rgm[i].caption:='Motor '+IntToStr(i);
    rgm[i].width:=81;rgm[i].height:= 73;
    rgm[i].show;
    end;
  if not checkbox1.checked then
     for i:=5 to 8 do
        begin  rgm[i].visible:=false; rgm[i].free; rgm[i]:=nil; end;
  for i:=1 to 16 do
   if s_eing[i]=nil then   begin
   s_eing[i]:=tshape.create(self);
   l_eing[i]:=tlabel.Create(self);
   s_eing[i].parent:=self;
   l_eing[i].parent:=self;
   s_eing[i].shape:=stcircle;
   s_eing[i].Brush.color:=clred;
   s_eing[i].width:=20;
   l_eing[i].width:=10;
   s_eing[i].top:=150;
   l_eing[i].top:=200;
   s_eing[i].left:=10+40*i+60*((i-1) div 8);
   l_eing[i].left:=13+40*i+60*((i-1) div 8);
   l_eing[i].caption:='E'+IntToStr(i);
   s_eing[i].enabled:=true; // true:sichtbar; false:mit Formularroutinen arbeiten
   s_eing[i].show
   end;
   if not checkbox1.checked then
      for i:=9 to 16 do
        begin s_eing[i].free; s_eing[i]:=nil;  l_eing[i].free; l_eing[i]:=nil end;
   F_FTUSB.timer1.enabled:=true;
   b_schliessen.enabled:=true;
   b_oeffnen.enabled:=false;
   F_FTUSB.caption:='Fischertechnik USB-verbunden';
end;

procedure TF_FTUSB.FormCreate(Sender: TObject);
begin
  ok:=false; //_Anzahl_interfaces:=1;
end;

procedure TF_FTUSB.CheckBox1Click(Sender: TObject);
var i:integer;
begin
   if ok then exit;
   if checkbox1.checked then begin // _Anzahl_interfaces:=2;
                              F_FTUSB.width:=810;
                              e_ez.visible:=true;
                              e_et.visible:=true;
                              label4.visible:=true;
                              label5.visible:=true;
                              label6.visible:=true;
                              label7.visible:=true;
                              spE_2pnr.visible:=true;
                              end
                       else begin // _Anzahl_interfaces:=1;
                              F_FTUSB.width:=420;
                              e_ez.visible:=false;
                              e_et.visible:=false;
                              label4.visible:=false;
                              label5.visible:=false;
                              label6.visible:=false;
                              label7.visible:=false;
                              spE_2pnr.visible:=false;
for i:=5 to 8 do  if rgm[i]<>nil then begin  rgm[i].visible:=false;  end;
for i:=9 to 16 do if s_eing[i]<>nil then begin l_eing[i].visible:=false; s_eing[i].visible:=false end;
                              end;
end;

procedure TF_FTUSB.FormActivate(Sender: TObject);
begin
 setfocus
end;

procedure TF_FTUSB.e_exKeyPress(Sender: TObject; var Key: Char);
begin
    if key='Z' then checkbox1.visible:=true
               else checkbox1.visible:=false
end;

end.
