unit _MB_USB;

interface
 uses windows,sysutils,dialogs,controls,forms;
function taster(k:byte):boolean;
function poti(z:char):byte;
procedure motor(nr:byte;richtung:char);
function _port_oeffnen(nr:byte):Byte;
function _port2_oeffnen(nr:byte):Byte;
procedure _port_schliessen;
procedure _port2_schliessen;

var _Anzahl_interfaces:integer;

implementation

const verzoegerung=2500; //ms warten statt Endlosschleife
      uebertragung='4800,n,8,1';     //muss auch im Interface anders gesetzt werden!

// verwendete Methoden der RS2COM.DLL von B. Kainka
// http://www.b-kainka.de/pcmessfaq.htm
Function OPENCOM(OpenString:PChar):Integer;stdcall; external 'RS2COM.DLL';
Function OPENCOM2(OpenString:PChar):Integer;stdcall; external 'RS2COM.DLL';
Procedure TIMEOUTS (TOut: Integer); stdcall; external 'RS2COM.DLL';
Procedure BUFFERSIZE (Size: Integer); stdcall; external 'RS2COM.DLL';
Procedure CLOSECOM(); stdcall; external 'RS2COM.DLL';
Procedure CLOSECOM2(); stdcall; external 'RS2COM.DLL';
Procedure SENDBYTE (Dat: Integer); stdcall; external 'RS2COM.DLL';
Function READBYTE (): Integer; stdcall; external 'RS2COM.DLL';
Function READBYTE2 (): Integer; stdcall; external 'RS2COM.DLL';
Procedure SENDSTRING (Buffer: PChar); stdcall; external 'RS2COM.DLL';
Procedure SENDSTRING2 (Buffer: PChar); stdcall; external 'RS2COM.DLL';
Function READSTRING (): PChar; stdcall; external 'RS2COM.DLL';
Function READSTRING2 (): PChar; stdcall; external 'RS2COM.DLL';
Procedure CLEARBUFFER (); stdcall; external 'RS2COM.DLL';
Procedure CLEARBUFFER2 (); stdcall; external 'RS2COM.DLL';
Function INBUFFER (): DWORD; stdcall; external 'RS2COM.DLL';
Function INBUFFER2 (): DWORD; stdcall; external 'RS2COM.DLL';
Function OUTBUFFER (): DWORD; stdcall; external 'RS2COM.DLL';
Procedure DTR(d:WORD); stdcall; external 'RS2COM.DLL';
Procedure DTR2(d:WORD); stdcall; external 'RS2COM.DLL';
Procedure RTS(d:WORD); stdcall; external 'RS2COM.DLL';
Procedure TXD(d:WORD); stdcall; external 'RS2COM.DLL';
Function CTS:Integer; stdcall; external 'RS2COM.DLL';
Function DSR:Integer; stdcall; external 'RS2COM.DLL';
Function RI:Integer; stdcall; external 'RS2COM.DLL';
Function DCD:Integer; stdcall; external 'RS2COM.DLL';
function INPUTS():Integer; stdcall; external 'RS2COM.DLL';
procedure TIMEINIT(); stdcall; external 'RS2COM.DLL';
function TIMEREAD(): Real; stdcall; external 'RS2COM.DLL';
procedure DELAY(DelayTime: Real); stdcall; external 'RS2COM.DLL';
procedure REALTIME(); stdcall; external 'RS2COM.DLL';
procedure NORMALTIME(); stdcall; external 'RS2COM.DLL';


function taster(k:byte):boolean;
var c:byte; s:string;  t:byte;
begin
  if (k<1) or (k>16) then begin result:=false; exit end;
  if (k<=8) then begin       //1. Interface
  s:='E'+IntToStr(k);
  sendstring(PChar(s));
  repeat until inbuffer=3;
  s:='';
  while inbuffer>0 do begin c:=readbyte; s:=s+char(c); end;
   if Copy(s,2,2)='OK' then result:=(s[1]='0') else result:=false;
  end
else if _Anzahl_interfaces=1 then begin result:=false; exit end
                else  begin    //2.Interface
  s:='E'+IntToStr(k-8);
  sendstring2(PChar(s));
  repeat until inbuffer2=3;
  s:='';
  while inbuffer2>0 do begin c:=readbyte2; s:=s+char(c); end;
  if Copy(s,2,2)='OK' then result:=(s[1]='0') else result:=false;
 end
end;


function poti(z:char):byte;
var s:string; c:byte;
begin
  if z in ['X','Y'] then begin  // 1. Interface
    s:='E'+z;
      sendstring(PChar(s));
      repeat until inbuffer=3;
      s:='';
      while inbuffer>0 do  begin c:=readbyte; s:=s+char(c); end;
      if Copy(s,2,2)='OK' then  result:=Ord(s[1]) ;
    end
  else if _Anzahl_interfaces=2 then begin
    if z in ['Z','T'] then begin   //2. Interface
      if z='Z' then z:='X' else z:='Y';
      s:='E'+z;
      sendstring2(PChar(s));
      repeat until inbuffer2=3;
      s:='';
      while inbuffer2>0 do  begin c:=readbyte2; s:=s+char(c); end;
      if Copy(s,2,2)='OK' then result:=Ord(s[1]);
      end;
    end;
  end;

procedure motor(nr:byte;richtung:char);
var s:string;
begin if (nr <= 4) and (nr >= 1) then begin           // 1. Interface
      sendstring(PChar('M'+IntToStr(nr)+richtung));
      repeat until inbuffer>0;
      s:='';
      while inbuffer>0 do s:=s+char(readbyte);
      clearbuffer;
      end
 else if (_Anzahl_interfaces=2) and (nr>=5) and (nr<=8) then begin  // 2. Interface
      sendstring2(PChar('M'+IntToStr(nr - 4)+richtung));
      repeat until inbuffer2>0;
      s:='';
      while inbuffer2>0 do s:=s+char(readbyte2);
      clearbuffer2;
      end
end;

function _port_oeffnen(nr:byte):byte;
var s:string;  startzeit:integer;  c:byte;
begin
{result 0: ok, 1: COM-Port ffnet nicht, 2: kein OK zurck}
   result:=1; //Damit wird jedenfalls ein Fehlerwert gesetzt
   startzeit:=gettickcount;
   if OpenCom (Pchar('COM'+IntToStr(nr)+':'+uebertragung))>0 then begin //geffnet
      result:=0;
      dtr(1);  // Das braucht unser Interface
      //jetzt prfen ob OK durch Probeabfrage von E1
      s:='E2';  sendstring(PChar(s)); s:='';
      repeat until (inbuffer=3) or (gettickcount>startzeit+verzoegerung); //Endlosschleife abfangen
      while inbuffer>0 do begin c:=readbyte; s:=s+char(c); end;
      if Copy(s,2,2)<>'OK' then begin result:=2; exit end //kein OK erhalten
                           else inc(_Anzahl_interfaces);
   end
      else
   result:=1; //COM-Port ffnet nicht!
end;

function _port2_oeffnen(nr:byte):byte;
var s:string;  startzeit:integer;  c:byte;
begin
{result 0: ok, 1: COM-Port ffnet nicht, 2: kein OK zurck}
   result:=1; //Damit wird jedenfalls ein Fehlerwert gesetzt
   startzeit:=gettickcount;
   if OpenCom2 (Pchar('COM'+IntToStr(nr)+':'+uebertragung))>0 then begin //geffnet
      result:=0; // d.h. ok
      dtr2(1);
      //jetzt prfen ob OK durch Probeabfrage von E1
      s:='E2';  sendstring2(PChar(s)); s:='';
      repeat until (inbuffer2=3) or (gettickcount>startzeit+verzoegerung); //Endlosschleife abfangen
      while inbuffer2>0 do begin c:=readbyte2; s:=s+char(c); end;
      if Copy(s,2,2)<>'OK' then begin result:=2; exit end //kein OK erhalten
                           else inc(_Anzahl_interfaces); // alles ok
   end
      else
   result:=1; //2. COM-Port ffnet nicht!
end;


procedure _port_schliessen;
begin
  dec(_Anzahl_interfaces);
  closecom
end;

procedure _port2_schliessen;
begin
  dec(_Anzahl_interfaces);
  closecom2
end;

begin
  _Anzahl_interfaces:=0
  {Diese Variable erleichert im Testprogramm die Arbeit.
   Sie wird von _open_port und _close_port schreibend verwaltet.
   Sonst nur lesender Zugriff!}
end.
